<?php
/**
 * @package DWD_Custom_FullWidth_Header_Extended
 * @version 1.2.5
 */
/*
Plugin Name: Divi Custom FullWidth Header Extended
Plugin URI: https://diviwebdesign.com/
Description: A Custom Fullwidth Header for Divi Builder. Start building and impress your visitors with title effects, background effects, animation and more!
Author: Divi Web Design
Version: 1.2.5
Author URI: https://diviwebdesign.com/
*/
define( 'DWD_PLUGIN_URL', plugin_dir_url( __FILE__ ) );
function dwd_header_extended () {
	//css
    wp_enqueue_style('dwd-animate', DWD_PLUGIN_URL . 'css/animate.css');
    wp_register_style('dwd-fullwidth', DWD_PLUGIN_URL . 'css/dwd-fullwidth-header.css');
    //js
    wp_register_script('dwd-animaton-load', DWD_PLUGIN_URL . 'js/animation-load.js', array('jquery'), '1.0', true);
    wp_register_script('dwd-typed', DWD_PLUGIN_URL . 'js/typed.js', array('jquery'), null, true);
    wp_register_script('dwd-typed-script', DWD_PLUGIN_URL . 'js/headertypingeffect.js', array('jquery'), null, true);
    wp_register_script('dwd-lettering', DWD_PLUGIN_URL . 'js/jquery.lettering.js', array('jquery'), null, true);
    wp_register_script('dwd-textillate', DWD_PLUGIN_URL . 'js/jquery.textillate.js', array('dwd-lettering'), null, true);
    wp_register_script('dwd-textillate-start', DWD_PLUGIN_URL . 'js/textillate-start.js', array('dwd-textillate'), null, true);
    wp_register_script('dwd-morptext', DWD_PLUGIN_URL . 'js/morphext.min.js', array('jquery'), null, false);
    wp_register_script('dwd-textrotator', DWD_PLUGIN_URL . 'js/textrotator.js', array('dwd-morptext'), '1.0', true);
    wp_register_script('dwd-particles', DWD_PLUGIN_URL . 'js/particles.min.js', array('jquery'), null, true);
    wp_register_script('dwd-particles-start', DWD_PLUGIN_URL . 'js/particles-start.js', array('dwd-particles'), null, true);
    wp_register_script('dwd-animated-bg', DWD_PLUGIN_URL . 'js/animated-bg.js', array('jquery'), null, true);
    wp_register_script('dwd-animated-transparent-bg', DWD_PLUGIN_URL . 'js/animated-transparent-bg.js', array('jquery'), null, true);
}
add_action( 'wp_enqueue_scripts', 'dwd_header_extended' );

function dwd_header_extended_admin() {
    wp_enqueue_style('dwd-header-style', DWD_PLUGIN_URL . 'css/admin-header-extended.css');
}
add_action('admin_enqueue_scripts', 'dwd_header_extended_admin');

function DWD_Fullwidth_Header_Extended(){
	if(class_exists("ET_Builder_Module")){
		include('fullwidth-header-extended.php');
	}
}

add_action('et_builder_ready', 'DWD_Fullwidth_Header_Extended');